#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

int a[1002][1002];
int f[1002][1002];
int p[1002][1002];
int n, A, B;
bool check(int mid){
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            f[i][j] = (a[i][j] <= mid);
            p[i][j] = 0;
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            p[i][j] = p[i-1][j] + p[i][j-1] - p[i-1][j-1] + f[i][j];
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            for(int iter = 0; iter < 2; iter++){
                if(i >= A && j >= B){
                    int sum = p[i][j] - p[i-A][j] - p[i][j-B] + p[i-A][j-B];
                    if(sum == A*B)
                        return true;
                }
                swap(A, B);
            }
        }
    }
    return false;
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> A >> B;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin >> a[i][j];
        }
    }
    int left = 0, right = n * n + 1;
    while((right - left) > 1){
        int mid = (left + right) / 2;
        if(check(mid)){
            right = mid;
        }else{
            left = mid;
        }
    }
    cout << right;
    return 0;
}
