#include<bits/stdc++.h>

using namespace std;

const int MAXN=1001;
pair<int, int> q[MAXN*MAXN];
pair<int, int> tab[MAXN][MAXN];
int n;
int a, b;

void update(int i, int j, bool up)
{
    if(up)
    {
        int u=i, d=i;
        while(u>0 && tab[u-1][j].first>0)
            u--;
        while(d<n-1 && tab[d+1][j].first>0)
            d++;

        int h=d-u+1;
        for(int y=u;y<=d;y++)
            tab[y][j].first=h;
    }
    else
    {
        int r=j, l=j;
        while(l>0 && tab[i][l-1].first>0)
            l--;
        while(r<n-1 && tab[i][r+1].first>0)
            r++;

        int w=r-l+1;
        for(int x=l;x<=r;x++)
            tab[i][x].second=w;
    }
}

void add(int i, int j)
{

    tab[i][j].first=1;
    tab[i][j].second=1;

    if((i>0 && tab[i-1][j].first>0) ||
        (i<n-1 && tab[i+1][j].first>0))
    {
        update(i, j, true);
    }

    if((j>0 && tab[i][j-1].first>0) ||
        (j<n-1 && tab[i][j+1].first>0))
    {
        update(i, j, false);
    }
}

bool check(int i, int j)
{
    while(i>0 && ((tab[i-1][j].first>=a && tab[i-1][j].second>=b) ||
                  (tab[i-1][j].first>=b && tab[i-1][j].second>=a)))
            i--;
    while(j>0 && ((tab[i][j-1].first>=a && tab[i][j-1].second>=b) ||
                  (tab[i][j-1].first>=b && tab[i][j-1].second>=a)))
            j--;

    int A=a, B=b;

    if(!(tab[i][j].first>=A && tab[i][j].second>=B))//???
        swap(A, B);

    bool fl=true;
    for(int x=i;x<i+a;x++)
    {
        for(int y=j;y<j+b;y++)
        {
            if(!(tab[x][y].first>=A && tab[x][y].second>=B))
            {
                fl=false;
                goto MARK;
            }
        }
    }

    MARK:
    return fl;
}

int main()
{
    //cin.tie(0);

    cin>>n>>a>>b;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            int z;
            cin>>z;

            q[z].first=i;
            q[z].second=j;

            tab[i][j].first=0;
            tab[i][j].second=0;
        }
    }

    for(int i=1;i<n*n+1;i++)
    {
        int x=q[i].first, y=q[i].second;
        add(x, y);

        if((tab[x][y].first>=a && tab[x][y].second>=b) ||
            (tab[x][y].first>=b && tab[x][y].second>=a))
        {
            if(check(x, y))
            {
                cout<<i;
                break;
            }

        }
    }



	return 0;
}
