#include<bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")

struct State{
    int color;
    int pos;
    bool direction; //false left
    //operator=(State &s){pos = s.pos; color = s.color; direction = s.direction;}
    State(){}
    State(int c, int p, bool d){pos = p; color = c; direction = d;}
};

bool stateComp(const State &s1, const State &s2){
    return s1.pos < s2.pos;
}

const bool DEBUG = false;
const int SIZE = 200;

char src[SIZE][SIZE];
State row[SIZE];
int n, m;
void input(){
        if(DEBUG){
        ifstream cin("CableTest1.txt");
        cin>>n>>m;
        for(int i=0; i<n; i++){
            for(int j=0; j<m; j++){
                cin>>src[i][j];
            }
        }
    } else {
        cin>>n>>m;
        for(int i=0; i<n; i++){
            for(int j=0; j<m; j++){
                cin>>src[i][j];
            }
        }
    }
}

void solve(){
    int k=0;
    for(int i=0; i<m; i++){
        if(src[0][i] == '/'){
            row[k].color = k+1;
            row[k].pos = i-1;
            row[k].direction = 0;
            k++;
        } else if(src[0][i] == 92){
            row[k].color=k+1;
            row[k].pos = i+1;
            row[k].direction = 1;
            k++;
        }
    }
    for(int i=1; i<n-1; i++){
        if(DEBUG){
            for(int i=0; i<k; i++)
                cout<<row[i].pos<<' ';
            cout<<'\n';
        }
        for(int j=0; j<k; j++){
            char c = src[i][row[j].pos];
            if(c=='/' || c==')'){
                row[j].pos--;
                row[j].direction = false;
            } else if (c==92 || c=='('){
                row[j].pos++;
                row[j].direction = true;
            } else{
                row[j].pos += (row[j].direction ? 1 : -1);
            }
        }
    }
    if(DEBUG){
        for(int i=0; i<k; i++){
            cout<<row[i].pos<<' ';
        }
        cout<<'\n';
    }
    sort(row, row+k, stateComp);
    for(int i=0; i<k; i++)
        cout<<row[i].color<<' ';

}

int main(){
    input();
    solve();
    return 0;
}

